# Uses of Interface
net.shibboleth.idp.attribute.resolver.DataConnector

Packages that use DataConnector
Package
Description
net.shibboleth.idp.attribute.resolver
A system which is capable of retrieving a collection of `IdPAttribute`s from a variety of locations, transform them, and associate a set of protocol-specific encoders to them.
net.shibboleth.idp.attribute.resolver.context
The context to do with Attribute Resolution.
net.shibboleth.idp.attribute.resolver.dc
Interfaces supporting data connectors.
net.shibboleth.idp.attribute.resolver.dc.http.impl
A `DataConnector` implementation that reads data from an HTTP web service.
net.shibboleth.idp.attribute.resolver.dc.impl
Common functionality used by data connectors.
net.shibboleth.idp.attribute.resolver.dc.impl.testing
Testing utility classes.
net.shibboleth.idp.attribute.resolver.dc.ldap.impl
A `DataConnector` implementation that reads data from an LDAP.
net.shibboleth.idp.attribute.resolver.dc.rdbms.impl
A `DataConnector` implementation that reads data from a relational database.
net.shibboleth.idp.attribute.resolver.dc.saml.impl
A `DataConnector` implementation that queries data from a SAML attribute authority.
net.shibboleth.idp.attribute.resolver.dc.scripted.impl
Classes which make up the scripted data connector.
net.shibboleth.idp.attribute.resolver.dc.storage.impl
Implementation of StorageService-backed data connector.
net.shibboleth.idp.attribute.resolver.impl
Implementations of core resolver functionality.
net.shibboleth.idp.attribute.resolver.testing
Testing utility classes.
net.shibboleth.idp.saml.attribute.resolver.impl
Implementations of SAML related `AttributeDefinition` and `DataConnector`.

## Uses of DataConnector in net.shibboleth.idp.attribute.resolver

Classes in net.shibboleth.idp.attribute.resolver that implement DataConnector
Modifier and Type
Class
Description
`class`
`AbstractDataConnector`
Base class for data connector resolver plugins.
`final class`
`ResolvedDataConnector`
A proxy which wraps a resolved data connector and always returns the same attributes.
Fields in net.shibboleth.idp.attribute.resolver declared as DataConnector
Modifier and Type
Field
Description
`private final DataConnector`
ResolvedDataConnector.`resolvedConnector`
The data connector that was resolved to produce the attributes.
Methods in net.shibboleth.idp.attribute.resolver that return DataConnector
Modifier and Type
Method
Description
`DataConnector`
ResolvedDataConnector.`getResolvedConnector()`
Gets the wrapped data connector that was resolved.
Constructors in net.shibboleth.idp.attribute.resolver with parameters of type DataConnector
Modifier
Constructor
Description
``
`ResolvedDataConnector(DataConnector connector, Map<String,IdPAttribute> attributes)`
Constructor.

## Uses of DataConnector in net.shibboleth.idp.attribute.resolver.context

Methods in net.shibboleth.idp.attribute.resolver.context with parameters of type DataConnector
Modifier and Type
Method
Description
`void`
AttributeResolverWorkContext.`recordDataConnectorResolution(DataConnector connector, Map<String,IdPAttribute> attributes)`
Records the results of an data connector resolution.
`void`
AttributeResolverWorkContext.`recordFailoverResolution(DataConnector failedConnector, DataConnector failoverConnector)`
Transfer the attributes from a failover data connector to a failed one.

## Uses of DataConnector in net.shibboleth.idp.attribute.resolver.dc

Methods in net.shibboleth.idp.attribute.resolver.dc with parameters of type DataConnector
Modifier and Type
Method
Description
`void`
Validator.`validate(DataConnector dataConnector)`
Probe the data connector and conditionally fails if it is not valid and ready for use.

## Uses of DataConnector in net.shibboleth.idp.attribute.resolver.dc.http.impl

Classes in net.shibboleth.idp.attribute.resolver.dc.http.impl that implement DataConnector
Modifier and Type
Class
Description
`class`
`HTTPDataConnector`
This class implements a `DataConnector` that obtains data from an HTTP service.

## Uses of DataConnector in net.shibboleth.idp.attribute.resolver.dc.impl

Classes in net.shibboleth.idp.attribute.resolver.dc.impl that implement DataConnector
Modifier and Type
Class
Description
`class`
`AbstractSearchDataConnector<T1 extends ExecutableSearch,T2 extends MappingStrategy<?>>`
A `DataConnector` containing functionality common to data connectors that retrieve attribute data by searching a data source.
`class`
`ContextDerivedDataConnector`
A data connector which returns attributes whose values are derived from the `ProfileRequestContext` associated with the request via a plugged in `Function`.
`class`
`PairwiseIdDataConnector`
A `DataConnector` that generates pairwise IDs that depend on a seed `IdPAttribute`.
`class`
`StaticDataConnector`
A `DataConnector` that just returns a static collection of attributes.

## Uses of DataConnector in net.shibboleth.idp.attribute.resolver.dc.impl.testing

Classes in net.shibboleth.idp.attribute.resolver.dc.impl.testing that implement DataConnector
Modifier and Type
Class
Description
`class`
`SAMLAttributeDataConnector`
Data Connector to extra attributes from a saml2 `Assertion`.

## Uses of DataConnector in net.shibboleth.idp.attribute.resolver.dc.ldap.impl

Classes in net.shibboleth.idp.attribute.resolver.dc.ldap.impl that implement DataConnector
Modifier and Type
Class
Description
`class`
`LDAPDataConnector`
A `DataConnector` that queries an LDAP in order to retrieve attribute data.
Methods in net.shibboleth.idp.attribute.resolver.dc.ldap.impl with parameters of type DataConnector
Modifier and Type
Method
Description
`void`
ConnectionFactoryValidator.`validate(DataConnector dataConnector)`
Probe the data connector and conditionally fails if it is not valid and ready for use.

## Uses of DataConnector in net.shibboleth.idp.attribute.resolver.dc.rdbms.impl

Classes in net.shibboleth.idp.attribute.resolver.dc.rdbms.impl that implement DataConnector
Modifier and Type
Class
Description
`class`
`RDBMSDataConnector`
A `DataConnector` that queries a relation database in order to retrieve attribute data.
Methods in net.shibboleth.idp.attribute.resolver.dc.rdbms.impl with parameters of type DataConnector
Modifier and Type
Method
Description
`void`
DataSourceValidator.`validate(DataConnector dataConnector)`
Probe the data connector and conditionally fails if it is not valid and ready for use.

## Uses of DataConnector in net.shibboleth.idp.attribute.resolver.dc.saml.impl

Classes in net.shibboleth.idp.attribute.resolver.dc.saml.impl that implement DataConnector
Modifier and Type
Class
Description
`class`
`SAMLDataConnector`
A `DataConnector` implementation which queries a SAML attribute authority for attribute data.
`class`
`SimpleAggregationSAMLDataConnector`
A `DataConnector` implementation which orchestrates calling `SAMLDataConnector` for each of a resolved list of attribute authority entityIDs, and aggregates the resolved attribute data.
Methods in net.shibboleth.idp.attribute.resolver.dc.saml.impl with parameters of type DataConnector
Modifier and Type
Method
Description
`void`
SAMLDataConnector.NullValidator.`validate(DataConnector dataConnector)`
Probe the data connector and conditionally fails if it is not valid and ready for use.

## Uses of DataConnector in net.shibboleth.idp.attribute.resolver.dc.scripted.impl

Classes in net.shibboleth.idp.attribute.resolver.dc.scripted.impl that implement DataConnector
Modifier and Type
Class
Description
`class`
`ScriptedDataConnector`
A Data Connector which populates a series of attributes from a provided `ProfileRequestContext`.
Methods in net.shibboleth.idp.attribute.resolver.dc.scripted.impl with parameters of type DataConnector
Modifier and Type
Method
Description
`void`
ScriptedDataConnector.NullValidator.`validate(DataConnector dataConnector)`
Probe the data connector and conditionally fails if it is not valid and ready for use.

## Uses of DataConnector in net.shibboleth.idp.attribute.resolver.dc.storage.impl

Classes in net.shibboleth.idp.attribute.resolver.dc.storage.impl that implement DataConnector
Modifier and Type
Class
Description
`class`
`StorageServiceDataConnector`
This class implements a `DataConnector` that obtains data from a `StorageService`.

## Uses of DataConnector in net.shibboleth.idp.attribute.resolver.impl

Fields in net.shibboleth.idp.attribute.resolver.impl with type parameters of type DataConnector
Modifier and Type
Field
Description
`private Map<String,DataConnector>`
AttributeResolverImpl.`dataConnectors`
Data connectors defined for this resolver.
Methods in net.shibboleth.idp.attribute.resolver.impl that return types with arguments of type DataConnector
Modifier and Type
Method
Description
`Map<String,DataConnector>`
AttributeResolverImpl.`getDataConnectors()`
Gets the unmodifiable collection of data connectors for this resolver.
Method parameters in net.shibboleth.idp.attribute.resolver.impl with type arguments of type DataConnector
Modifier and Type
Method
Description
`void`
AttributeResolverImpl.`setDataConnectors(Collection<DataConnector> connectors)`
Sets the data connectors for this resolver.

## Uses of DataConnector in net.shibboleth.idp.attribute.resolver.testing

Classes in net.shibboleth.idp.attribute.resolver.testing that implement DataConnector
Modifier and Type
Class
Description
`class`
`MockDataConnector`
A data connector that just returns a static collection of attributes.
`class`
`MockStaticDataConnector`
An attribute definition that simply returns a static value.
`private static class`
`TestSources.StaticDataConnector`
Helper class.
Methods in net.shibboleth.idp.attribute.resolver.testing that return DataConnector
Modifier and Type
Method
Description
`static DataConnector`
TestSources.`populatedStaticConnector()`
Create a static connector with known attributes and values.
`static DataConnector`
TestSources.`populatedStaticConnector(List<IdPAttribute> attributes)`
Create a static connector with provided attributes and values.

## Uses of DataConnector in net.shibboleth.idp.saml.attribute.resolver.impl

Classes in net.shibboleth.idp.saml.attribute.resolver.impl that implement DataConnector
Modifier and Type
Class
Description
`class`
`EntityAttributesDataConnector`
A `DataConnector` that returns the decoded `EntityAttributes` from a peer's metadata.